<?php

include "common.php";

use Animarr\Release\Release;
use Animarr\Downloader;

if(!isset($_GET["release_id"])){
    header("Location: index.php");
    die();
}
$release_id = preg_replace("[^a-fA-f0-9]", "", $_GET["release_id"]);
$release = $database->getRelease($release_id);
if($release === null){
    header("Location: index.php");
    die();
}

$downloader = new Downloader($database);
$downloader->forceAddToDownload($release->getParent() !== null ? $release->getParent() : $release);
$downloader->handleNewDownloads();
header("Location: index.php");
die();
